/**
 * 
 */
package edu.cmu.radar.dynaweb;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;

import edu.cmu.radar.dynaweb.entities.Location;
import edu.cmu.radar.dynaweb.utils.HibernateUtils;

/**
 * @author Jialiang
 *
 */
public class DynaWebServicesImpl implements DynaWebServices {

	/* (non-Javadoc)
	 * @see edu.cmu.radar.dynaweb.DynaWebServices#getLocation(java.lang.String)
	 */
	public List<Location> getLocation(String building) {
		Session session = HibernateUtils.getSession();
		
		Query query = session.createQuery("from Location where building=?");
		query.setString(0, building);
		List list = query.list();
		
		HibernateUtils.close(session);
		
		return list;
	}

	/* (non-Javadoc)
	 * @see edu.cmu.radar.dynaweb.DynaWebServices#getLocation(java.lang.String, java.lang.String)
	 */
	public List<Location> getLocation(String building, String type) {
		Session session = HibernateUtils.getSession();
		
		Query query = session.createQuery("from Location where building=? and type=?");
		query.setString(0, building);
		query.setString(1, type);
		List list = query.list();
		
		HibernateUtils.close(session);
		
		return list;
	}

}
