/**
 *
 */
package edu.cmu.radar.dynaweb.actions;

import java.text.DecimalFormat;
import java.text.Format;
import java.util.List;

import edu.cmu.radar.dynaweb.entities.Location;

/**
 * @author Jialiang
 *
 * A Struts action provides room data for FlagStaff
 */
public class FlagStaffRoomAction extends RoomAction {
	/**
	 * the room list
	 * */
	private List<Room> rooms;

	/**
	 * the formatted capacity name list
	 * */
	private List<String> fmtCapNames;

	/**
	 * the room capacity formatter
	 * */
	private static CapacityFormat format = new FlagStaffCapacityFormat();

	/**
	 * loads the room data and formats the capacity names and values
	 */
	public String execute() throws Exception {
		List<Location> locations = services.getLocation("Flagstaff");
		List<String> capNames = getCapacityNames(locations);
		fmtCapNames = getFormattedCapacityNames(capNames);
		rooms = getRooms(locations, capNames, format);

		return SUCCESS;
	}

	/**
	 * @return the rooms
	 */
	public List<Room> getRooms() {
		return rooms;
	}

	/**
	 * @return the fmtCapNameList
	 */
	public List<String> getFmtCapNames() {
		return fmtCapNames;
	}

}

/**
 * A room capacity formatter that formats decimal values in the pattern of "#,###"
 * */
class FlagStaffCapacityFormat implements CapacityFormat {
	Format squareFormat = new DecimalFormat("#,###");

	/*
	 * (non-Javadoc)
	 *
	 * @see edu.cmu.radar.dynaweb.actions.CapacityFormat#format(java.lang.String,
	 *      java.lang.String)
	 */
	public String format(String configuration, String capacity) {
		if (configuration == null || capacity == null) {
			return "n/a";
		}
		try {
		if (!"0".equals(capacity) && (Integer.parseInt(capacity)==0)) {
			return "n/a";
		}
		} catch (Exception e) {
			return "n/a";
		}


		try {
			if ("square".equalsIgnoreCase(configuration)) {
				int square = Integer.parseInt(capacity);
				return squareFormat.format(square);
			}

			return capacity;
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		return null;
	}

}
