/**
 *
 */
package edu.cmu.radar.dynaweb.actions;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @author Jialiang
 *
 * A struts action that provides room data for Mehrabian Hall
 */
public class MehrabianRoomAction extends RoomAction {
	/**
	 * the room data categorized by types
	 * */
	private Map<String, List<Room>> roomsMap = new HashMap<String, List<Room>>();

	/**
	 * the room capacity formatter
	 * */
	private static CapacityFormat format = new MehrabianCapacityFormat();

	/**
	 * the formatted room-capacity names categorized by types
	 * */
	private Map<String, List<String>> fmtCapNamesMap = new HashMap<String, List<String>>();

	/*
	 * (non-Javadoc)
	 *
	 * @see com.opensymphony.xwork2.ActionSupport#execute()
	 */
	public String execute() throws Exception {
		String building = "Mehrabian";
		loadRooms(building, "classroom", roomsMap, fmtCapNamesMap, format);
		loadRooms(building, "conference", roomsMap, fmtCapNamesMap, format);

		return SUCCESS;
	}

	/**
	 * @return the roomsMap
	 */
	public Map<String, List<Room>> getRoomsMap() {
		return roomsMap;
	}

	/**
	 * @return the fmtCapNamesMap
	 */
	public Map<String, List<String>> getFmtCapNamesMap() {
		return fmtCapNamesMap;
	}
}

class MehrabianCapacityFormat implements CapacityFormat {

	/*
	 * (non-Javadoc)
	 *
	 * @see edu.cmu.radar.dynaweb.actions.CapacityFormat#format(java.lang.String,
	 *      java.lang.String)
	 */
	public String format(String configuration, String capacity) {
		if (configuration == null || capacity == null) {
			return "n/a";
		}
		try {
		if (!"0".equals(capacity) && (Integer.parseInt(capacity)==0)) {
			return "n/a";
		}
		} catch (Exception e) {
			return "n/a";
		}



		return capacity;

	}

}

