-- NOTE by Robert McGuire 3/30/2006: This file should be broken up into two
-- separate files, www.form.sql and www.field.sql.  Due to the deeply-embedded
-- nature of the use of the form/field sequence counters to set form/field
-- relationships, however, I am going to wait until the site and forms get an
-- overhaul when hell freezes over (ed. ids).

-- START of www.form + www.field combo  --

-- insert into www.form, the formName (ie Person)
-- and the sql to be used for combo box in picker.jsp 
--   ie what to display in the combo box [and ordered by what field]
-- the actual table name in psql
-- insert each field of table
--  specify what order it should appear in forms, what caption, etc

-- changes:
-- form ID is now auto generated sequence.
-- INSERT into field uses current value of sequence
--   instead of being hard-coded as done previously

--   START of people table --

-- An error might be expected in the next line, since
--   www.fieldposition might not have been created before (1st instantiation)

-- website roles
INSERT INTO www.role (id, name, role) VALUES (1, 'Public', null);
INSERT INTO www.role (id, name, role) VALUES (2, 'Internal Use Only', 'internal');

--drop sequence www.formposition;
create sequence www.formposition;
insert into www.formgroup (name, caption, sitehref) 
	values ('ardra', 'Ardra Website Form System', 'index.jsp');

--drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'News',
	'select www.news.id as key, www.news.header from www.news order by www.news.header',
	nextval('www.formposition'),
	'www.news',
	'index.jsp?preview=1&rtarget=1'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'header',
	'Header',
	true,
	nextval('www.fieldposition'),
	'field',
	'www.news.header'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'body',
	'Body',
	true,
	nextval('www.fieldposition'),
	'textarea',
	'www.news.body'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'newsdate',
	'News Date',
	true,
	nextval('www.fieldposition'),
	'field',
	'www.news.date'
);


insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain) values (
	currval('www.form_id_seq'),
	'person_id',
	'Author',
	true,
	'base.person',
	nextval('www.fieldposition'),
	'dropdown',
	'select base.person.id as key, base.person.first, base.person.last from base.person order by base.person.last',
	'base.person.id'
);


-- person
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'Person',
	'select base.person.id as key, base.person.first, base.person.last from base.person order by base.person.last',
	nextval('www.formposition'),
	'base.person',
	'index.jsp?renderer=getBio&eid='
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'first',
	'First Name',
	true,
	nextval('www.fieldposition'),
	'field',
	'base.person.first'
);


insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'middle',
	'Middle Name',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.person.middle'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'last',
	'Last Name',
	true,
	nextval('www.fieldposition'),
	'field',
	'base.person.last'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'officephone',
	'Office Phone',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.person.officephone'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'faxphone',
	'Fax Number',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.person.faxphone'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'email',
	'Email',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.person.email'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'organization',
	'Organization',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.person.organization'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'personalhref',
	'Personal Web Page',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.person.personalhref'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'bio',
	'Biography/Interests',
	false,
	nextval('www.fieldposition'),
	'textarea',
	'base.person.bio'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, linktablename, linktableid, linktablevalue)
values (
	currval('www.form_id_seq'),
	'position',
	'Conference Role',
	false,
	'www.position',
	nextval('www.fieldposition'),
	'multi-combo',	
	'select www.position.ID as key, www.position.caption from www.position order by www.position.caption', 
	'www.person_position',
	'person_id',
	'position_id'
);

--  END of people table --

-- sponsors
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'Sponsor',
	'select base.sponsor.id as key, base.sponsor.name from base.sponsor order by base.sponsor.name',
	nextval('www.formposition'),
	'base.sponsor',
	'index.jsp?preview=1&rtarget=3'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'name',
	'Sponsor Name',
	true,
	nextval('www.fieldposition'),
	'field',
	'base.sponsor.name'
);

-- end of sponsors

--   START of gathering table --

drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'Event',
	'select id as key, caption, title from cmradar.meetinghierarchy where meetingtype = ''GG'' order by caption',
	nextval('www.formposition'),
	'cmradar.meetinghierarchy',
	'index.jsp?renderer=getEvent&eid='
);

insert into www.field (form_id, name, caption, required, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'meetingtype',
	'ARDRA Event Type',
	true,
	nextval('www.fieldposition'),
	'hidden',
	'GG',
	'cmradar.meetingheirarchy.type'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'caption',
	'Caption',
	true,
	nextval('www.fieldposition'),
	'field',
	'cmradar.meetinghierarchy.caption'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'title',
	'Title',
	true,
	nextval('www.fieldposition'),
	'field',
	'cmradar.meetinghierarchy.title'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'eventtype_id',
	'Event Type',
	true,
	'www.eventtype',
	nextval('www.fieldposition'),
	'dropdown',
	'select www.eventtype.id as key, www.eventtype.caption from www.eventtype order by www.eventtype.caption',
	'www.eventtype.id'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'meetingdate',
	'Date (e.g. 2005-01-13)',
	false,
	nextval('www.fieldposition'),
	'field',
	'cmradar.meetingheirarchy.meetingdate'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'starttime',
	'Time (e.g. 13:30:00)',
	false,
	nextval('www.fieldposition'),
	'field',
	'cmradar.meetingheirarchy.starttime'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'duration',
	'Duration (in Seconds)',
	false,
	nextval('www.fieldposition'),
	'field',
	'cmradar.meetingheirarchy.duration'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'location_id',
	'Location',
	false,
	'base.location',
	nextval('www.fieldposition'),
	'dropdown',
	'select base.location.id as key, base.location.caption from base.location order by base.location.caption',
	'base.location.id'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'person_id',
	'Chair/Host (Speaker for plenary/keynote)',
	false,
	'base.person',
	nextval('www.fieldposition'),
	'dropdown',
	'select base.person.id as key, base.person.first, base.person.last from base.person order by base.person.last, base.person.first',
	'base.person.id'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, linktablename, linktableid, linktablevalue)
values (
	currval('www.form_id_seq'),
	'person',
	'Speaker (for Panel, Tutorial)',
	false,
	'base.person',
	nextval('www.fieldposition'),
	'multi-combo',
	'select base.person.id as key, base.person.first, base.person.last from base.person order by base.person.last, base.person.first',
	'base.gathering_person_speaker',
	'gathering_id',
	'person_id'
);

--   END of gathering table --

--   START of presentation table --
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'Presentation',
	'select www.presentation.id as key, www.presentation.title from www.presentation order by www.presentation.title',
	nextval('www.formposition'),
	'www.presentation',
	'index.jsp?renderer=getPresentation&eid='
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'gathering_id',
	'Event',
	false,
	'cmradar.meetinghierarchy',
	nextval('www.fieldposition'),
	'dropdown',
	'SELECT cmradar.meetinghierarchy.id AS key, cmradar.meetinghierarchy.caption FROM cmradar.meetinghierarchy WHERE cmradar.meetinghierarchy.meetingtype=''GG'' ORDER BY cmradar.meetinghierarchy.caption',
	'cmradar.meetinghierarchy.id'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'speaker',
	'Speaker',
	true,
	'base.person',
	nextval('www.fieldposition'),
	'dropdown',
	'select base.person.id as key, base.person.first, base.person.last from base.person order by base.person.last, base.person.first',
	'base.person.id'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'title',
	'Title',
	true,
	nextval('www.fieldposition'),
	'field',
	'www.presentation.title'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'abstract',
	'Abstract',
	false,
	nextval('www.fieldposition'),
	'textarea',
	'www.presentation.abstract'
);

--   END of www.presentation table --

--   START of location table --
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'Location',
	'select base.location.id as key, base.location.caption from base.location order by base.location.caption',
	nextval('www.formposition'),
	'base.location',
	null
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'caption',
	'Caption',
	true,
	nextval('www.fieldposition'),
	'field',
	'base.location.caption'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'building',
	'Building',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.location.building'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'floor',
	'Floor',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.location.floor'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'type',
	'Type',
	false,
	nextval('www.fieldposition'),
	'field',
	'base.location.type'
);

--   END of location table --

--   START of eventtype table --
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl, showtoplevel) 
values (
	currval('www.formgroup_id_seq'),
	'Event Type',
	'select www.eventtype.id as key, www.eventtype.caption from www.eventtype order by www.eventtype.caption',
	nextval('www.formposition'),
	'www.eventtype',
	null,
	false
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'name',
	'Name',
	true,
	nextval('www.fieldposition'),
	'field',
	'www.eventtype.name'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'caption',
	'Caption',
	true,
	nextval('www.fieldposition'),
	'field',
	'www.eventtype.caption'
);

--   END of eventtype table -- 

--   START of position table --
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl, showtoplevel) 
values (
	currval('www.formgroup_id_seq'),
	'Position',
	'select www.position.id as key, www.position.caption from www.position order by www.position.caption',
	nextval('www.formposition'),
	'www.position',
	null,
	false
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'caption',
	'Name',
	true,
	nextval('www.fieldposition'),
	'field',
	'www.position.caption'
);

--   END of position table --

--   START of text table --
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl, showtoplevel) 
values (
	currval('www.formgroup_id_seq'),
	'Site Text',
	'select www.text.id as key, www.category.caption from www.text,www.category,www.categorylink where www.text.id = www.categorylink.item_id and www.category.id = www.categorylink.category_id order by www.category.caption',
	nextval('www.formposition'),
	'www.text',
	null,
	false
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'html',
	'Contents',
	true,
	nextval('www.fieldposition'),
	'textarea',
	'www.text.html'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, linktablename, linktableid, linktablevalue, domain)
values (
	currval('www.form_id_seq'),
	'category',
	'Category (page)',
	true,
	'www.category',
	nextval('www.fieldposition'),
	'multi-combo',
	'select www.category.id as key, www.category.caption from www.category order by www.category.caption',
	'www.categorylink',
	'item_id',
	'category_id',
	null
);
--   END of text table --

--   START of category table --

drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl, showtoplevel) 
values (
	currval('www.formgroup_id_seq'),
	'Category',
	'select www.category.id as key, www.category.caption from www.category order by www.category.caption',
	nextval('www.formposition'),
	'www.category',
	null,
	false
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'caption',
	'Name',
	true,
	nextval('www.fieldposition'),
	'field',
	'www.category.caption'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'parent',
	'Parent Category',
	false,
	'www.category',
	nextval('www.fieldposition'),
	'dropdown',
	'select www.category.id as key, www.category.caption from www.category order by www.category.caption',
	'www.category.id'
);

--- END of category table -- 

--- START of www.file table ---
drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl, showtoplevel) 
values (
	currval('www.formgroup_id_seq'),
	'File',
	'select www.file.id as key, www.file.name from www.file order by www.file.name',
	nextval('www.formposition'),
	'www.file',
	null,
	false
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'data',
	'File',
	true,
	nextval('www.fieldposition'),
	'file',
	'none'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'role_id',
	'Access Level',
	true,
	'www.role',
	nextval('www.fieldposition'),
	'dropdown',
	'select www.role.id as key, www.role.name from www.role order by key',
	'www.role.id'
);
--- END of www.file table ---

--- END of ardra forms --

--- START of pim forms --
drop sequence www.formposition;
create sequence www.formposition;
insert into www.formgroup (name, caption, sitehref) 
	values ('vot', 'Vendor Order Tracker', 'index.jsp');

-- START of Vendor Orders table --

drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'Vendor Order',
	'SELECT id as key, externaltransaction_id, vendor, title, eventdate FROM pim.vendororder ORDER BY externaltransaction_id, title, eventdate',
	nextval('www.formposition'),
	'pim.vendororder',
	null
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'vendor',
	'Vendor',
	true,
	nextval('www.fieldposition'),
	'field',
	'pim.vendororder.vendor'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'title',
	'Event Title',
	true,
	nextval('www.fieldposition'),
	'field',
	'pim.vendororder.title'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'location',
	'Event Location',
	true,
	nextval('www.fieldposition'),
	'field',
	'pim.vendororder.location'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'eventdate',
	'Event Date',
	true,
	nextval('www.fieldposition'),
	'field',
	'pim.vendororder.eventdate'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'starttime',
	'Event Start Time',
	false,
	nextval('www.fieldposition'),
	'field',
	'pim.vendororder.starttime'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'endtime',
	'Event End Time',
	false,
	nextval('www.fieldposition'),
	'field',
	'pim.vendororder.endtime'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'quotedprice',
	'Quoted Price',
	true,
	nextval('www.fieldposition'),
	'field',
	'pim.vendororder.quotedprice'
);
        
insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
        'formurl',
        'Edit Order URL',
        false,
	nextval('www.fieldposition'),
        'field',
	'pim.vendororder.formurl'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
        'externaltransaction_id',
        'Order Identifier',
        false,
	nextval('www.fieldposition'),
        'field',
	'pim.vendororder.externaltransaction_id'
);

insert into www.field (form_id, name, caption, required, subform, position, entrytype, entryquery, domain)
values (
	currval('www.form_id_seq'),
	'status',
	'Status',
	true,
	'pim.orderstate',
	nextval('www.fieldposition'),
	'dropdown',
	'SELECT id as key, name FROM pim.orderstate ORDER BY id',
	'pim.orderstate.id'
);



-- END of Vendor Orders table --

-- START of Quotes table --

drop sequence www.fieldposition;
create sequence www.fieldposition;
insert into www.form (formgroup_id, caption, key, position, tablename, previewurl) 
values (
	currval('www.formgroup_id_seq'),
	'Quote',
	'SELECT id as key, externaltransaction_id, vendor, quotedprice, formurl FROM pim.quote ORDER BY externaltransaction_id, vendor, quotedprice, formurl',
	nextval('www.formposition'),
	'pim.quote',
	null
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'vendor',
	'Vendor',
	true,
	nextval('www.fieldposition'),
	'field',
	'pim.quote.vendor'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
	'quotedprice',
	'Quoted Price',
	true,
	nextval('www.fieldposition'),
	'field',
	'pim.quote.quotedprice'
);

insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
        'externaltransaction_id',
        'Order Identifier',
        false,  
	nextval('www.fieldposition'),
        'field',
	'pim.quote.externaltransaction_id'
);
          
insert into www.field (form_id, name, caption, required, position, entrytype, domain)
values (
	currval('www.form_id_seq'),
        'formurl',
        'Accept URL',
        false,  
	nextval('www.fieldposition'),
        'field',
	'pim.quote.formurl'
);

-- END of Quotes table --
