package airspaceGUI.base.test;

import javax.swing.JFrame;

import junit.framework.Test;
import junit.framework.TestSuite;

import airspaceGUI.base.event.MeetingPanel;
import airspaceGUI.model.AgentModel;
import airspaceGUI.model.MeetingModel;
import airspaceGUI.model.RoomModel;

public class MeetingPanelTest extends SubPanelTest
{

    JFrame frame = new JFrame();

    
    public static Test suite() {
        TestSuite suite = new TestSuite("CorpusGUI Tests");

        // add individual test classes
        suite.addTestSuite(MeetingPanelTest.class);

        return suite;
    }
    
    protected void setUp() throws Exception {
        super.setUp();
        if (thisPanel == null)
        {
            if(!this.getClass().equals(DataKeeper.lastClass)){
                DataKeeper.meetingModel = new MeetingModel(session);
                DataKeeper.roomModel = new RoomModel(session);
                DataKeeper.agentModel = new AgentModel(session);
                DataKeeper.lastClass = this.getClass();
                }
            //I am unsure if this is necessary...
            session.evict(DataKeeper.meetingModel);
            session.evict(DataKeeper.roomModel);
            session.evict(DataKeeper.agentModel);
            thisPanel = new MeetingPanel(session, DataKeeper.meetingModel, 
                    DataKeeper.roomModel, DataKeeper.agentModel);
            frame.getContentPane().add(thisPanel.getPane());
            frame.pack();
        }
        frame.setVisible(true);
    }

    protected void tearDown() throws Exception {
        super.tearDown();
        frame.setVisible(false);
    }
    
    public void testDeleteDisplayedObject(){
        super.testDeleteDisplayedObject();
        // this failure has been remedied
        //fail("need to figure out how to bring the object back so it doesn't screw things up");
    }

}
