package airspaceGUI.base.test;

import java.awt.AWTException;
import java.awt.Robot;
import java.io.File;

import javax.swing.JFrame;

import junit.framework.Test;
import junit.framework.TestSuite;

import org.hibernate.Session;
import org.hibernate.cfg.Configuration;

import airspaceGUI.base.person.PeoplePanel;
import airspaceGUI.model.AgentModel;
import airspaceGUI.model.PeopleModel;
import airspaceGUI.model.RoomModel;
import airspaceGUI.model.VariableModel;


public class TempRobot
{

    /**
     * @param args
     */
    public static void main(String[] args) {
        Session session;
        PeopleModel peopleModel;
        RoomModel roomModel;
        VariableModel variableModel;
        AgentModel agentModel;
            try
            {
                // Create the SessionFactory from hibernate.cfg.xml

                final File configFile = new File("corpus.hibernate.xml");
                final Configuration config = new Configuration()
                        .configure(configFile);

                session = config.buildSessionFactory().openSession();
                
                peopleModel = new PeopleModel(session);
                roomModel = new RoomModel(session);
                variableModel = new VariableModel(session);
                agentModel = new AgentModel(session);

            } catch (Exception ex)
            {
                // Make sure you log the exception, as it might be swallowed
                System.err.println("Initial SessionFactory creation failed." + ex);
                throw new ExceptionInInitializerError(ex);
            }
            
            JFrame frame = new JFrame();
            PeoplePanel peoplePanel = new PeoplePanel(null, peopleModel, session);
            frame.getContentPane().add(peoplePanel.getPane());
            frame.pack();
            frame.setVisible(true);
            frame.validate();
    }

}
