package airspaceGUI.expansion;

import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.SwingUtilities;

/**
 * This shows a spinny icon to inform the user that the program is busy doing
 * stuff rather than frozen or otherwise unresponsive
 * 
 * @author srbennet
 * 
 */
public class SmallBusyIndicator extends JLabel
{

    private static ImageIcon spinnyIcon1 = new ImageIcon("Throbber.gif");

    private final Runnable closerRunner = new Runnable()
    {
        public void run() {
            dispose();
        }
    };

    private final Thread thisThread = new Thread("BusyThread")
    {
        public void run() {
            // try
            {
                synchronized (SmallBusyIndicator.this)
                {
                    while (!done)
                    {
                        //System.out.println("RUNNING");
                        /*
                         * sleep(250);
                         * SmallBusyIndicator.this.setVisible(!SmallBusyIndicator.this.isVisible());
                         * System.out.println(SmallBusyIndicator.this.isVisible());
                         * SmallBusyIndicator.this.getTopLevelAncestor().validate();
                         * SmallBusyIndicator.this.getTopLevelAncestor().repaint();
                         */
                        // Thread.yield();
                        //System.out.println("In while loop");
                        thisThread.interrupt();
                    }
                    SwingUtilities.invokeLater(closerRunner);
                }

            } /*
                 * catch (InterruptedException e) { // TODO Auto-generated catch
                 * block e.printStackTrace(); }
                 */
        }
    };;

    private boolean done = false;

    public SmallBusyIndicator()
    {
        super(spinnyIcon1);
        /*
         * setText("Busy");
         * setBorder(BorderFactory.createLineBorder(Color.BLACK));
         */
        setVisible(false);
    }

    private void dispose() {
        //System.out.println("This should stop spinning now");
        this.setVisible(false);
    }

    /**
     * Starts the busy indicator spinning
     *
     */
    public void startSpinning() {
        //System.out.println("Spinning");
        this.setVisible(true);
        done = false;
    }

    /**
     * Stops the busy indicator from spinning
     *
     */
    public void stopSpinning() {
        //System.out.println("Stop spinning");
        done = true;
        this.setVisible(false);
    }

}
