package airspaceGUI.model;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.criterion.Order;

import edu.cmu.radar.base.Gathering;
import edu.cmu.radar.base.cmradar.AbstractMeeting;
import edu.cmu.radar.base.cmradar.ConcreteMeeting;


public class MeetingModel extends ArrayList
{

    private transient final List meetingList;
    
    public MeetingModel(final Session s)
    {
        super();
        List rawEvents = s.createCriteria(AbstractMeeting.class).addOrder(
                Order.asc("id")).list();
        
        /*for(int i = 0; i < rawEvents.size(); i++)
        {
            if (!(rawEvents.get(i) instanceof Gathering))
            {
                meetingList.add(rawEvents.get(i));
            }
        }*/
        meetingList = rawEvents;
        //meetingList.removeAll(s.createCriteria(Gathering.class).list());
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#add(int, java.lang.Object)
     */
    public void add(final int arg0, final Object arg1) {
        // only actually add concrete or abstract meetings
        if (arg1 instanceof AbstractMeeting && !(arg1 instanceof Gathering))
        {
            meetingList.add(arg0, arg1);
        }
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#add(java.lang.Object)
     */
    public boolean add(final Object arg0) {
//      only actually add concrete or abstract meetings
        if (arg0 instanceof AbstractMeeting && !(arg0 instanceof Gathering))
        {
            return meetingList.add(arg0);
        } else
        {
            return false;
        }
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#addAll(java.util.Collection)
     */
    public boolean addAll(final Collection arg0) {
        return meetingList.addAll(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#addAll(int, java.util.Collection)
     */
    public boolean addAll(final int arg0, final Collection arg1) {
        return meetingList.addAll(arg0, arg1);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#contains(java.lang.Object)
     */
    public boolean contains(final Object arg0) {
        return meetingList.contains(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#get(int)
     */
    public Object get(final int arg0) {
        return meetingList.get(arg0);
    }
    
    /**
     * Retrieves the meeting whose string representation is meetingString, null if it doesn't exist
     * @param meetingString the string representation of the meeting you are looking for
     * @return the meeting whose string is meetingString, null if one doesn't exist
     */
    public AbstractMeeting findMeeting(String meetingString) {
        AbstractMeeting result = null;
        
        String[] meetingTokens = meetingString.split("( in )");
        
        //System.out.println(meetingTokens.length);
        for(int i = 0; i < meetingList.size(); i++)
        {
            boolean correctDate = false;
            boolean correctLocation = false;
            for(int j = 0; j < meetingTokens.length; j++)
            {
                String currentToken = meetingTokens[j];
                
                if (currentToken.equals(((ConcreteMeeting)meetingList.get(i)).getMeetingdate().toString()))
                {
                    correctDate = true;
                } else if (meetingTokens.length > j+1)
                {
                    currentToken += " in " + meetingTokens[j+1];
                    
                    if (currentToken
                            .equals(((ConcreteMeeting)meetingList.get(i)).getLocation().toString()))
                    {
                        correctLocation = true;
                    }
                }
            }
            if (correctDate && correctLocation)
            {
                return (AbstractMeeting)meetingList.get(i);
            }
        }
            
        return result;
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#indexOf(java.lang.Object)
     */
    public int indexOf(final Object arg0) {
        return meetingList.indexOf(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#isEmpty()
     */
    public boolean isEmpty() {
        return meetingList.isEmpty();
    }

    /* (non-Javadoc)
     * @see java.util.AbstractList#iterator()
     */
    public Iterator iterator() {
        return meetingList.iterator();
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#remove(int)
     */
    public Object remove(final int arg0) {
        return meetingList.remove(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#remove(java.lang.Object)
     */
    public boolean remove(final Object arg0) {
        return meetingList.remove(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#set(int, java.lang.Object)
     */
    public Object set(final int arg0, final Object arg1) {
        if (arg1 instanceof AbstractMeeting && !(arg1 instanceof Gathering))
        {
            return meetingList.set(arg0, arg1);
        } else
        {
            return null;
        }
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#size()
     */
    public int size() {
        return meetingList.size();
    }

    
}
