package airspaceGUI.model;

import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import org.hibernate.Session;
import org.hibernate.criterion.Order;

import edu.cmu.radar.base.corpus.Variable;

public class VariableModel extends ArrayList
{
    ArrayList variablesList = new ArrayList();
    
    Session session; // a place to store the session so we can save the variables again

    public VariableModel(Session s)
    {
        session = s;
        List variableList = s.createCriteria(
                Variable.class).addOrder(Order.asc("name")).list();

        for (int i = 0; i < variableList.size(); i++)
        {
            variablesList.add(variableList.get(i));
        }
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#add(int, java.lang.Object)
     */
    public void add(int arg0, Object arg1) {
        variablesList.add(arg0, arg1);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#add(java.lang.Object)
     */
    public boolean add(Object arg0) {
        return variablesList.add(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#addAll(java.util.Collection)
     */
    public boolean addAll(Collection arg0) {
        return variablesList.addAll(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#clear()
     */
    public void clear() {
        variablesList.clear();
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#contains(java.lang.Object)
     */
    public boolean contains(Object arg0) {
        return variablesList.contains(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#get(int)
     */
    public Object get(int arg0) {
        return variablesList.get(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#indexOf(java.lang.Object)
     */
    public int indexOf(Object arg0) {
        return variablesList.indexOf(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#isEmpty()
     */
    public boolean isEmpty() {
        return variablesList.isEmpty();
    }

    /* (non-Javadoc)
     * @see java.util.AbstractList#iterator()
     */
    public Iterator iterator() {
        return variablesList.iterator();
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#remove(int)
     */
    public Object remove(int arg0) {
        return variablesList.remove(arg0);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#remove(java.lang.Object)
     */
    public boolean remove(Object arg0) {
        return variablesList.remove(arg0);
    }
    
    /**
     * Saves the variables back to the database in case any have changed/been added.
     * @return true if the save succeeded
     */
    public boolean save()
    {
        if (session != null && (!session.isConnected() || !session.isOpen()))
        {
            session.beginTransaction();
        }

        if (session != null)
        {
            for (int i = 0; i < variablesList.size(); i++)
            {
                if (variablesList.get(i) != null)
                {
                    session.saveOrUpdate(variablesList.get(i));
                }
            }

            //session.flush();
            session.getTransaction().commit();
            session.beginTransaction();
            return true;
        } else
        {
            return false;
        }
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#set(int, java.lang.Object)
     */
    public Object set(int arg0, Object arg1) {
        return variablesList.set(arg0, arg1);
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#size()
     */
    public int size() {
        return variablesList.size();
    }

    /* (non-Javadoc)
     * @see java.util.ArrayList#toArray()
     */
    public Object[] toArray() {
        return variablesList.toArray();
    }
    
    /**
     * This returns the variable in its data store whose name is equal to the string in the parameter
     * @param name
     *            the name of the variable to return
     * @return the variable whose name is name.
     */
    public Variable getVariable(String name) {
        Iterator variableItr = variablesList.iterator();
        Variable workingOn;
        String nameOnly = name;
        // Go through and check all the variables in the iterator
        // for the given name.
        if (name.matches(airspaceGUI.base.corpus.Variable.VARIABLEVERIFICATION))
        {
            nameOnly = name.substring(name.indexOf("\"") + 1, name
                    .lastIndexOf("\""));
        }

        while (variableItr.hasNext())
        {
            workingOn = (Variable)variableItr.next();
            if (workingOn.getName().equals(nameOnly))
            {
                return workingOn;
            }
        }

        return null;

    }   
    
}

