package openinjector;

import java.io.File;
import java.io.FileFilter;


/**
 * This class specifies which files to accept into a FileFilter according to the filename pattern
 *  passed to the constructor
 * @author srbennet
 *
 */
public class ExpandWildCardFileNames implements FileFilter
{
    private String fullPath;
    
    ExpandWildCardFileNames(String filename)
    {
        //save the filepath to compare against paths passed to the accept function
        fullPath = filename.replace(".", "\\.").replace("*", ".*");
    }

    
    public boolean accept(File path) {
        boolean matchesPath = path.getAbsolutePath().matches(fullPath);
        return matchesPath ;
    }

}
